//+------------------------------------------------------------------+
//|                                        Non lag ma v7.101 MTF.mq4 |
//|                                Copyright  2007, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|   mtf:FXTSD.com                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_width1 1
#property indicator_color2 Tomato
#property indicator_width2 1
#property indicator_color3 LimeGreen
#property indicator_width3 2
#property indicator_color4 Tomato
#property indicator_width4 2
//---- input parameters
/*****************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
********************************************************************/
//---- 
extern int TimeFrame=0;
extern int     Price          = 0;  //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close) 
extern int     Length         = 15;  //Period of NonLagMA
extern int     Displace       = 0;  //DispLace or Shift 
extern double  PctFilter      = 0.5;  //Dynamic filter in decimal
extern int     Color          = 1;  //Switch of Color mode (1-color)  
extern int     ColorBarBack   = 1;  //Bar back for color mode
extern double  Deviation      = 0;  //Up/down deviation        
extern int     AlertMode      = 0;  //Sound Alert switch (0-off,1-on) 
extern int     WarningMode    = 0;  //Sound Warning switch(0-off,1-on) 
extern int     NBars          = 500;
extern string note1 = "Price(OCHLMTF)Length(period)Displace(shift)Color(0/1)";

//---- indicator buffers
double MABuffer[];
double UpBuffer[];
double DnBuffer[];
double UpbBuffer[];
double DnbBuffer[];
double slope[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   IndicatorBuffers(6);
   SetIndexBuffer(0,UpBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,UpbBuffer); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,DnbBuffer); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,MABuffer);
   SetIndexBuffer(5,slope);
   string short_name;
//---- indicator line
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="Non lag ma v7.101 MTF ["+Length+"] TF ("+TimeFrame+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,""+short_name+"");
   SetIndexLabel(1,""+short_name+"");
   SetIndexLabel(2,""+short_name+"");
//----
   SetIndexShift(0,Displace*TimeFrame/Period());
   SetIndexShift(1,Displace*TimeFrame/Period());
   SetIndexShift(2,Displace*TimeFrame/Period());
   
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   SetIndexEmptyValue(2,EMPTY_VALUE);
   
   SetIndexDrawBegin(0,0);
   SetIndexDrawBegin(1,0);
   SetIndexDrawBegin(2,0);

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
 //--  
   return(0);
  }
//+------------------------------------------------------------------+
//|   MTF_NonLagMA_v7.1                                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(Bars-counted_bars,2*TimeFrame/Period()),Bars-1);
           if (NBars>0) limit = MathMin(limit,NBars);

   //
   //
   //
   //
   //

   for(int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      MABuffer[i]=iCustom(NULL,TimeFrame,"Non lag MA v7.101", Price,Length,Displace,PctFilter,Color,ColorBarBack,Deviation,AlertMode,WarningMode,NBars,0,y);
      slope[i] = slope[i+1];
         if (MABuffer[i]>MABuffer[i+1]) slope[i] =  1;
         if (MABuffer[i]<MABuffer[i+1]) slope[i] = -1;
         if (slope[i] ==  1) { UpBuffer[i]=High[i]; DnBuffer[i]=Low[i]; UpbBuffer[i] = MathMax(Open[i],Close[i]); DnbBuffer[i] = MathMin(Open[i],Close[i]); }
         if (slope[i] == -1) { DnBuffer[i]=High[i]; UpBuffer[i]=Low[i]; DnbBuffer[i] = MathMax(Open[i],Close[i]); UpbBuffer[i] = MathMin(Open[i],Close[i]); }
   }  
   if (NBars>0) 
   {
      SetIndexDrawBegin(0,MathMax(Bars-NBars-1,0));
      SetIndexDrawBegin(1,MathMax(Bars-NBars-1,0));
      SetIndexDrawBegin(2,MathMax(Bars-NBars-1,0));
      SetIndexDrawBegin(3,MathMax(Bars-NBars-1,0));
   }
   return(0);
}

